package tw.com.iscom.lablistview;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;

public class MainActivity extends Activity {

    ListView lvAQI;
    //
    // JSON : {k1:v11, k2:v12 ..} ,
    //        [ {k1:v11, k2:v12 ..}, {k1:v21, k2:v22 ..}, {}    ]
    //        value : "String", 1, 23, true/false, 132.35, [...], {...}
    String[] siteName = {
            "台北0",
            "台北1",
            "台北2",
            "台北3",
            "台北4",
            "台北5",
            "台北6",
            "台北7",
            "台北8",
            "台北9",
            "台北10",
            "台北11",
            "台北12",
            "台北13",
            "台北14"
    };
    int[] aqi = {
            10, 11,12,13,14,15,16,17,18,19,20,21,22,23,24
    };

    ArrayList<HashMap<String,Object>> allSites = new ArrayList<HashMap<String,Object>>();
    SimpleAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //
        lvAQI = (ListView) findViewById(R.id.lvAQI);

        /*
        // 單一資料顯示 : ArrayAdapter
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(
                this,
                android.R.layout.simple_list_item_1,
                sitename
        );
        */

        // 預載資料
        for (int i=0; i<siteName.length; i++) {
            HashMap<String,Object> item = new HashMap<>();
            item.put("SiteName", siteName[i]);
            item.put("AQI", aqi[i]);
            // ...
            allSites.add(item);
        }

        //
        adapter = new SimpleAdapter(
                this,
                 allSites,
                 R.layout.myitem,
                 new String[] {"SiteName", "AQI" } ,
                 new int[] {R.id.tvSiteName, R.id.tvAQI}
        );
        //
        lvAQI.setAdapter(adapter);
        lvAQI.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {

            }
        });

        // 下載 OpenData
        new Thread(){
            @Override
            public void run() {
                loadOpenData("http://opendata.epa.gov.tw/ws/Data/AQI/?$format=json", allSites);
            }
        }.start();
    }
    //
    private void loadOpenData(String siteUrl, ArrayList<HashMap<String, Object>> allSites) {
        try {
            URL url = new URL(siteUrl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            InputStream is = conn.getInputStream();
            Reader rr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(rr);
            //
            StringBuffer sbuf = new StringBuffer();
            String line = br.readLine();
            while (line != null) {
                Log.i("JSON", line);
                sbuf.append(line+"\n");
                line = br.readLine();
            }
            // 先清除舊有資料
            allSites.clear();
            //
            JSONArray jsonArray = new JSONArray(sbuf.toString());
            for (int i=0; i<jsonArray.length(); i++) {
                JSONObject site = jsonArray.getJSONObject(i);
                String name = site.getString("SiteName");
                String  aqi = site.getString("AQI");
                //
                HashMap<String,Object> item = new HashMap<>();
                item.put("SiteName", name);
                item.put("AQI", aqi);
                // ...
                allSites.add(item);
            }
            // 若網路太快，加入延遲更新 3000ms :
            try {
                Thread.sleep(3000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            //
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    adapter.notifyDataSetChanged();
                }
            });

            //
        } catch (MalformedURLException e) {
            e.printStackTrace();
            // ....
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}
